#version 150

#moj_import <minecraft:fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec2 texCoord0;
in vec4 vertexColor;
in vec4 vertexShading;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    if (color.a < 0.1) {
        discard;
    }
	
	// alpha 252 for emissive
	// alpha 253 for emissive and no tint
	// alpha 254 for no tint
	
	if (!((color.a > 0.996 && color.a < 1.0) || (color.a > 0.992 && color.a < 0.996))) {
		color *= vertexColor * ColorModulator;
	}
	
	if (!(color.a > 0.988 && color.a < 0.996)) {
		color *= vertexShading;
	}

    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
